--freemarker template
<#include "RPTA-Makros"/>
<sqlvars>
<sqlvar name="rpta_exam_unit_dim_studiengang_exists">
select count(*) from rpta_resultset where uniquename='rpta_exam_unit_dim_studiengang';
</sqlvar>
<sqlvar name="rpta_resultset">
select uniquename from rpta_resultset where uniquename='rpta_exam_unit_dim_studiengang';
</sqlvar>
</sqlvars>
<#assign rpta_column_layouts = [{"uniquename":"rpta_exam_unit_dim_studiengang_note",
"caption":"Prüfungsergebnisse",
"rpta_resultset":"rpta_exam_unit_dim_studiengang",
"whereclause":"((modulart=''P'' and sourcesystem=6) or (part=''MP'' and sourcesystem=5))",
"description":"Prüfung und Noten"
}]
   />

<#assign rpta_columns = [

{"uniquename":"dim_studiengang_stg",
"srcfieldname":"dim_studiengang_stg",
"column_type":"physicalColumn",
"col_function":"",
"format_code":"",
"caption":"Fach",
"is_visible":"1",
"is_aggregate":0,
"visible_size":10,
"description":""},

{"uniquename":"dim_studiengang_abschluss",
"srcfieldname":"dim_studiengang_abschluss",
"column_type":"physicalColumn",
"col_function":"",
"format_code":"",
"caption":"Abschluss",
"is_visible":"1",
"is_aggregate":0,
"visible_size":10,
"description":""},

  {"uniquename":"sem_der_pruefung",
"srcfieldname":"sem_der_pruefung",
"targetfieldname":"sem_der_pruefung",
"column_type":"logicalColumn",
"col_function":"sem_der_pruefung",
"format_code":"",
"caption":"Semester der Prüfung",
"is_visible":"0",
"is_aggregate":0,
"visible_size":5,
"description":""},

  {"uniquename":"sem_der_pruefung_min_process",
"srcfieldname":"sem_der_pruefung",
"targetfieldname":"sem_der_pruefung_min_process",
"column_type":"processingColumn",
"col_function":"min",
"format_code":"",
"caption":"Semester der Prüfung (Min)",
"is_visible":"1",
"is_aggregate":1,
"visible_size":5,
"description":""},

  {"uniquename":"sem_der_pruefung_max_process",
"srcfieldname":"sem_der_pruefung",
"targetfieldname":"sem_der_pruefung_max_process",
"column_type":"processingColumn",
"col_function":"max",
"format_code":"",
"caption":"Semester der Prüfung (Max)",
"is_visible":"1",
"is_aggregate":1,
"visible_size":5,
"description":""},

{"uniquename":"elementnr",
"srcfieldname":"elementnr",
"column_type":"physicalColumn",
"col_function":"",
"format_code":"",
"caption":"pnr",
"is_visible":"1",
"is_aggregate":0,
"visible_size":10,
"description":""},

  {"uniquename":"pdtxt",
"srcfieldname":"pdtxt",
"column_type":"physicalColumn",
"col_function":"",
"format_code":"",
"caption":"Name der Prüfung",
"is_visible":"1",
"is_aggregate":0,
"visible_size":40,
"description":""},

  {"uniquename":"summe",
"srcfieldname":"summe",
"column_type":"physicalColumn",
"col_function":"sum",
"format_code":"",
"caption":"Teilnehmer",
"is_visible":"1",
"is_aggregate":1,
"visible_size":15,
"description":""},

  {"uniquename":"note_case",
"srcfieldname":"note",
"targetfieldname":"note_case",
"column_type":"logicalColumn",
"col_function":"(case when note > 6 then null else note end)",
"format_code":"",
"caption":"Durchschnittsnote % *",
"is_visible":"0",
"is_aggregate":0,
"visible_size":5,
"description":""},

  {"uniquename":"note_schnitt",
"srcfieldname":"note_case",
"targetfieldname":"note_schnitt",
"column_type":"processingColumn",
"col_function":"avg",
"format_code":"",
"caption":"Durchschnittsnote *",
"is_visible":"0",
"is_aggregate":1,
"visible_size":5,
"description":""},

  {"uniquename":"note_schnitt_case",
"srcfieldname":"note_schnitt",
"targetfieldname":"note_schnitt_case",
"column_type":"computedColumn",
"col_function":"case when summe < 5 then null else note_schnitt end",
"format_code":"",
"caption":"Durchschnittsnote *",
"is_visible":"1",
"is_aggregate":1,
"visible_size":25,
"description":""},

  {"uniquename":"pstatus_nb",
"srcfieldname":"pstatus",
"targetfieldname":"pstatus_nb",
"column_type":"logicalColumn",
"col_function":"(case when pstatus in (''NB'',''EN'') then 1 else 0 end)",
"format_code":"",
"caption":"Durchfallquote in % *",
"is_visible":"0",
"is_aggregate":0,
"visible_size":5,
"description":""},

  {"uniquename":"pstatus_nb_sum",
"srcfieldname":"pstatus_nb",
"targetfieldname":"pstatus_nb_sum",
"column_type":"processingColumn",
"col_function":"sum",
"format_code":"",
"caption":"Durchfallquote in % *",
"is_visible":"0",
"is_aggregate":1,
"visible_size":5,
"description":""},

  {"uniquename":"pstatus_nb_quote",
"srcfieldname":"pstatus_nb_sum",
"targetfieldname":"pstatus_nb_quote",
"column_type":"computedColumn",
"col_function":"case when summe < 5 then null else pstatus_nb_sum/summe::decimal(18,2)*100 end",
"format_code":"DEC_2",
"caption":"Durchfallquote in % *",
"is_visible":"1",
"is_aggregate":1,
"visible_size":25,
"description":""},

  {"uniquename":"pvermerk_ne",
"srcfieldname":"pvermerk",
"targetfieldname":"pvermerk_ne",
"column_type":"logicalColumn",
"col_function":"(case when pvermerk in (''NE'',''N'') then 1 else 0 end)",
"format_code":"",
"caption":"Nicht erschienen",
"is_visible":"0",
"is_aggregate":0,
"visible_size":5,
"description":""},

  {"uniquename":"pvermerk_ne_sum",
"srcfieldname":"pvermerk_ne",
"targetfieldname":"pvermerk_ne_sum",
"column_type":"processingColumn",
"col_function":"sum",
"format_code":"INTEGER",
"caption":"Nicht erschienen",
"is_visible":"1",
"is_aggregate":1,
"visible_size":25,
"description":""}


  ] />
 
 
   ---ab hier nicht mehr ändern:
   
CREATE temp TABLE tmp_rpta_column
(
   uniquename       varchar(255)   NOT NULL,
   caption          varchar(255),
   srcfieldname     varchar(255),
   targetfieldname  varchar(255),
   column_type      integer,
   col_function     text,
   is_visible       smallint,
   visible_size     smallint,
   is_aggregate     smallint,
   resultset_id     integer,
   sortnr integer,
   description TEXT,
   format_code_uniquename varchar(255),
   format_code_id integer
);

CREATE temp TABLE tmp_rpta_column_layout
(
    uniquename    varchar(255)   NOT NULL,
   caption       varchar(255),
   resultset_id  integer,
   whereclause text,
   description text
);


<#foreach rpta_column_layout in rpta_column_layouts>

insert into tmp_rpta_column_layout(
resultset_id,
uniquename,
caption,
whereclause,
  description
)
select tid,
'${rpta_column_layout.uniquename}',
'${rpta_column_layout.caption}',
'${rpta_column_layout.whereclause}',
'${rpta_column_layout.description}'
FROM rpta_resultset
where uniquename='${rpta_column_layout.rpta_resultset}';

</#foreach >

<#assign sortnr=0 />
<#foreach column in rpta_columns>
<#assign sortnr=sortnr +1 />

INSERT INTO tmp_rpta_column
(resultset_id,
  uniquename,
  caption,
  srcfieldname,
  targetfieldname,
  column_type,
  col_function,
  is_visible,
  visible_size,
  is_aggregate,
  sortnr,
  description,
  format_code_uniquename
  )
select R.tid,
'${column.uniquename}',
'${column.caption}',
'${column.srcfieldname}',
<#if !column.targetfieldname?exists || column.targetfieldname=="">null::varchar <#else>'${column.targetfieldname}' </#if>,
T.tid as column_type,
<#if column.col_function?exists>'${column.col_function}'<#else>null::varchar  </#if>,
${column.is_visible},
${column.visible_size},
${column.is_aggregate},
${sortnr*10},
<#if column.description?exists>'${column.description}'<#else>null::varchar  </#if>,
<#if column.format_code?exists>'${column.format_code}'<#else>null::varchar </#if>
FROM rpta_resultset R, rpta_column_type T
where R.uniquename='${rpta_resultset}'
and T.uniquename='${column.column_type}';

</#foreach>

update tmp_rpta_column set format_code_id=C.tid
from rpta_format_code C
where C.uniquename=tmp_rpta_column.format_code_uniquename
and format_code_uniquename is not null;


select * into temp tmp_rpta_column2layout
from rpta_column2layout
where layout_id in (select L.tid
from rpta_column_layout L,rpta_resultset R
where R.tid=L.resultset_id 
and R.uniquename='${rpta_resultset}'
and L.uniquename in (
<#foreach rpta_column_layout in rpta_column_layouts>
'${rpta_column_layout.uniquename}',
</#foreach>'xy')
)
; 
  
select * into temp tmp_rpta_column_layout_target
from rpta_column_layout
where resultset_id in (select tid
FROM rpta_resultset
where uniquename='${rpta_resultset}')
and uniquename in (select uniquename from tmp_rpta_column_layout)
;

insert into rpta_column_layout
(uniquename,
       caption,
       resultset_id,
       whereclause,
  description)
 select uniquename,
       caption,
       resultset_id,
       whereclause,
  description
FROM tmp_rpta_column_layout T
where 0=(select count(*) from tmp_rpta_column_layout_target T2
where T.uniquename=T2.uniquename);

drop table tmp_rpta_column_layout_target;

delete from rpta_column2layout
where layout_id in (select L.tid
from rpta_column_layout L,rpta_resultset R
where R.tid=L.resultset_id 
and R.uniquename='${rpta_resultset}'
and L.uniquename in (
<#foreach rpta_column_layout in rpta_column_layouts>
'${rpta_column_layout.uniquename}',
</#foreach>'xy')
)
; 

select * into temp tmp_rpta_column2 
from tmp_rpta_column T 
where (resultset_id,uniquename) not in
(select resultset_id,uniquename from rpta_column);

INSERT INTO rpta_column
(resultset_id,
  uniquename,
  caption,
  srcfieldname,
  targetfieldname,
  column_type,
  col_function,
  is_aggregate,
  description,
  custom
  )
  select 
resultset_id,
  uniquename,
  caption,
  srcfieldname,
  targetfieldname,
  column_type,
  col_function,
  is_aggregate,
  description,
  0 as custom
from tmp_rpta_column2; 

--evtl. neuen Satz einfügen, dann alle updaten

update rpta_column set (  caption,
  srcfieldname,
  targetfieldname,
  column_type,
  col_function,
  is_aggregate,
  description)
  = (select   caption,
  srcfieldname,
  targetfieldname,
  column_type,
  col_function,
  is_aggregate,
  description
  from tmp_rpta_column T
  where T.resultset_id=rpta_column.resultset_id
  and T.uniquename=rpta_column.uniquename)
  where custom=0
  and  (resultset_id,uniquename) in
(select T.resultset_id,T.uniquename
from tmp_rpta_column T)
;

drop table tmp_rpta_column2;

insert into rpta_column2layout(column_id,
       layout_id,
       sortnr,
       is_visible,
       visible_size,
       caption,
  description,
  format_code_id)
select C.tid as column_id,
       L.tid as layout_id,
       T.sortnr,
       T.is_visible,
       T.visible_size,
       T.caption,
  T.description,
  T.format_code_id
FROM rpta_column C,  rpta_column_layout L, tmp_rpta_column T
where C.uniquename=T.uniquename
and C.resultset_id=T.resultset_id
and L.uniquename in (
<#foreach rpta_column_layout in rpta_column_layouts>
'${rpta_column_layout.uniquename}',
</#foreach>'xy')
and L.resultset_id=T.resultset_id
 ;
drop table tmp_rpta_column;
drop table if exists tmp_rpta_column2;
drop TABLE tmp_rpta_column_layout;




