--freemarker template
<#include "RPTA-Makros"/>
<sqlvars>
<sqlvar name="rpta_installed">
select count(*) from systeminfo where tid=330;
</sqlvar>
</sqlvars>
<#assign rpta_column_layout = {"uniquename":"sgd_pbe_pbv",
"caption":"Stellen, Besetzungen und Beschäftigungsverhältnisse",
"rpta_resultset":"sva_pbe_aggr_sgd",
"whereclause":"",
"description":"Stellendaten, Besetzungen und Personaldaten"
}
   />

<#assign rpta_columns = [
{"uniquename":"ch110_besch_st",
"caption":"Beschäftigungsstelle (Schlüssel)",
"srcfieldname":"ch110_besch_st",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"10",
"is_aggregate":"0",
"description":"Beschäftigungsstelle (Schlüssel)"
},
{"uniquename":"ch110_besch_st_str",
"caption":"Beschäftigungsstelle",
"srcfieldname":"ch110_besch_st_str",
"column_type":"lookupColumn",
"col_function":"select C.druck from cifx C where C.key=110 and C.apnr=ch110_besch_st",
"is_visible":"1",
"visible_size":"10",
"is_aggregate":"0",
"description":"Beschäftigungsstelle (Name)"
},
{"uniquename":"stellen_nr",
"caption":"Stellen-Nr.",
"srcfieldname":"stellen_nr",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"0",
"description":"Stellen-Nr."
},
{"uniquename":"haushalt_nr",
"caption":"Stellen-Nr. im HH-Plan",
"srcfieldname":"haushalt_nr",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"0",
"description":"Stellen-Nr. im HH-Plan"
},
{"uniquename":"widmung",
"caption":"Widmung",
"srcfieldname":"sva_sgd_widmung",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"0",
"description":"Widmung"
},
{"uniquename":"sva_sgd_von",
"caption":"Stellengültigkeit (von)",
"srcfieldname":"d_finanz_anfang",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"0",
"description":"Stellengültigkeit (von)"
},
{"uniquename":"sva_sgd_bis",
"caption":"Stellengültigkeit (bis)",
"srcfieldname":"d_finanz_ende",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"0",
"description":"Stellengültigkeit (bis)"
},
{"uniquename":"sgd_ansatz",
"caption":"Stellen-Ansatz",
"srcfieldname":"kont_proz_soll",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"0",
"description":"Stellen-Ansatz"
},
{"uniquename":"personal_nr",
"caption":"Personal-Nr.",
"srcfieldname":"sva_pbe_aggr_personal_nr",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"0",
"description":""
},
{"uniquename":"besch_verh_nr",
"caption":"Besch.-Verh Nr.",
"srcfieldname":"sva_pbe_aggr_besch_verh_nr",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"0",
"description":""
},
{"uniquename":"name",
"caption":"Person Name",
"srcfieldname":"sva_pbe_aggr_name",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"0",
"description":""
},
{"uniquename":"d_besetz_anfang",
"caption":"Besetzung gültig (von)",
"srcfieldname":"sva_pbe_aggr_d_besetz_anfang",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"0",
"visible_size":"5",
"is_aggregate":"0",
"description":""
} ,
{"uniquename":"d_besetz_ende",
"caption":"Besetzung gültig (bis)",
"srcfieldname":"sva_pbe_aggr_d_besetz_ende",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"0",
"visible_size":"5",
"is_aggregate":"0",
"description":""
},
{"uniquename":"pbe_von",
"caption":"Besetzungsdatum (von)",
"srcfieldname":"sva_pbe_aggr_pbe_von",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"0",
"visible_size":"5",
"is_aggregate":"0",
"description":""
} ,
{"uniquename":"pbe_bis",
"caption":"Besetzungsdatum (bis)",
"srcfieldname":"sva_pbe_aggr_pbe_bis",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"0",
"visible_size":"5",
"is_aggregate":"0",
"description":""
},
{"uniquename":"vzae",
"caption":"VZÄ (Besetzung)",
"srcfieldname":"sva_pbe_aggr_vzae",
"column_type":"physicalColumn",
"col_function":"sum",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"1",
"description":""
} 
]
   />
 
<#if rpta_installed==1>
<@rpta_column_layout_fuellen />
</#if>
