--freemarker template
<#include "RPTA-Makros"/>
<sqlvars>
<sqlvar name="sos_stud_astat_exists">
select count(*) from rpta_resultset where uniquename='sos_stud_astat';
</sqlvar>
</sqlvars>
<#assign rpta_column_layout = {"uniquename":"sos_stud_astat_rsz",
"caption":"MKW-Abfrage_Studierende_RSZ",
"rpta_resultset":"sos_stud_astat",
"whereclause":"fach_sem_zahl <= dim_studiengang_regel and dim_studiengang_regel between 1 and 20 and studiengang_nr <=2 and fach_nr <=4",
"description":"Fachbelegungen: 1. & 2. Studiengang; 1.-4. Fach; nur Studiengänge mit Angabe einer Regelstudienzeit"
}
   />

<#assign rpta_columns = [
{"uniquename":"sos_k_stort_astat",
"caption":"Hochschulnummer Statistik",
"srcfieldname":"sos_k_stort_astat",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"10",
"is_aggregate":"0",
"description":"Amtliche Standortnummer"
},
{"uniquename":"dim_studiengang_stg_astat",
"caption":"HSF-Schlüssel",
"srcfieldname":"dim_studiengang_stg_astat",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"10",
"is_aggregate":"0",
"description":"Amtliches Fach"
},
{"uniquename":"sos_k_stufrm_astat",
"caption":"Art des Studiums",
"srcfieldname":"sos_k_stufrm_astat",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"10",
"is_aggregate":"0",
"description":"Amtliche Studienform"
},
{"uniquename":"dim_studiengang_abschluss_astat",
"caption":"Abschlussschlüssel Statistik NRW",
"srcfieldname":"dim_studiengang_abschluss_astat",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"10",
"is_aggregate":"0",
"description":"Amtlicher Abschluss"
},
{"uniquename":"sos_k_stutyp_astat",
"caption":"Vollzeit / Teilzeit / ausbildungsintegriert / praxisintegriert / berufsintegriert",
"srcfieldname":"sos_k_stutyp_astat",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"10",
"is_aggregate":"0",
"description":"Amtlicher Studiumstyp"
},
{"uniquename":"dim_studiengang_regel",
"caption":"Angabe der Regelstudienzeit",
"srcfieldname":"dim_studiengang_regel",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"1",
"visible_size":"10",
"is_aggregate":"0",
"description":"Regelstudienzeit in Semestern"
},
{"uniquename":"summe",
"caption":"Anzahl der Studierenden in der Regelstudienzeit",
"srcfieldname":"summe",
"column_type":"physicalColumn",
"col_function":"sum",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"1",
"description":"Summe der Studierenden mit Fachsemester kleiner oder gleich der Regelstudienzeit"
}
]
   />

   
<@rpta_column_layout_fuellen />
