<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns="http://jasperreports.sourceforge.net/jasperreports"
>
<xsl:import href="xsl_functions.xsl" />
<xsl:import href="rpta_templates.xsl" />

<xsl:param name="OUTFILE" select="'tmp'" />
<xsl:param name="seitenbreite" select="842" />
<xsl:param name="seitenhoehe" select="595" />
<xsl:param name="seitenrand" select="12" />
<xsl:param name="isIgnorePagination" select="'true'" />
<xsl:param name="orientation" select="'Landscape'" />
<xsl:param name="stylesFile" select="'simple_table.jrtx'" />
<xsl:param name="font" select="'Liberation Sans'" /><!--TODO Arial als style-->
<!--Die Breite der Tabelle in pixel bei A4 Querformat:-->
<!-- Wenn keine Spaltenbreite definiert ist, wird 12 (Einheit Applet-Breite) verwendet.  -->
<xsl:param name="std_spaltenbreite" select="'12'" />
<xsl:param name="std_zeilenhoehe_header" select="30" />
<xsl:param name="std_zeilenhoehe_tablerow" select="30" />

<xsl:output method="text" name="text"/>
<!--<xml:output method="xml" name="text" />-->
<xsl:output indent="yes"/>
<xsl:template match="/">
<xsl:variable name="druckbreite" select="$seitenbreite - (2 * $seitenrand)"></xsl:variable>
<xsl:choose>
<xsl:when test="/ergebnisse/@isMakro='true'">
<!-- first create main report-->
<xsl:call-template name="generateJasperReport" >
<xsl:with-param name="isMacroReport" select="'true'" />
<xsl:with-param name="ergebniselementOrdnr" select="0" />
<xsl:with-param name="druckbreite" select="$druckbreite" />
<xsl:with-param name="seitenbreite" select="$seitenbreite" />
<xsl:with-param name="seitenhoehe" select="$seitenhoehe" />
<xsl:with-param name="seitenrand" select="$seitenrand" />
<xsl:with-param name="stylesFile" select="$stylesFile" />
</xsl:call-template>
<!--output documents klappt noch nicht-->
<!--
<xsl:for-each select="/ergebnisse/ergebnis/ergebniselement">
<xsl:variable name="filename" select="concat($OUTFILE,@ordnr,'.jrxml')"/>
Generiere <xsl:value-of select="$filename"/><xsl:text>
</xsl:text>
<xsl:result-document href="{$filename}" format="text" method="text">
<xsl:call-template name="generateJasperReport" >
<xsl:with-param name="isMacroReport" select="'false'" />
<xsl:with-param name="ergebniselementOrdnr" select="@ordnr" />
<xsl:with-param name="druckbreite" select="$druckbreite" />
</xsl:call-template>
</xsl:result-document>
</xsl:for-each>
-->
</xsl:when>
<xsl:otherwise>
<!--no macro, one single table-->
<xsl:call-template name="generateJasperReport" >
<xsl:with-param name="isMacroReport" select="'false'" />
<xsl:with-param name="ergebniselementOrdnr" select="0" />
<xsl:with-param name="druckbreite" select="$druckbreite" />
<xsl:with-param name="seitenbreite" select="$seitenbreite" />
<xsl:with-param name="seitenhoehe" select="$seitenhoehe" />
<xsl:with-param name="seitenrand" select="$seitenrand" />
<xsl:with-param name="std_zeilenhoehe_tablerow" select="$std_zeilenhoehe_tablerow" />
<xsl:with-param name="stylesFile" select="$stylesFile" />
</xsl:call-template>
</xsl:otherwise>
</xsl:choose>
</xsl:template>



</xsl:stylesheet>
